/**************************************************************** 
 * Description: 
 * Author: Alex Li
 * Date: 2024-01-23 20:10:39
 * LastEditTime: 2024-01-23 22:37:37
****************************************************************/
#include <iostream>
using namespace std;

// 定义树的结点结构
struct Node {
    int data;           // 存储结点的数据
    struct Node *left, *right;  // 指向左子结点和右子结点的指针
};

Node*  a[1000000]; // 创建一个数组，用来存储指向每个结点的指针

// 创建新结点的函数
Node* newNode(int data){
    Node* temp = new Node; // 分配新的结点
    temp->data = data;     // 设置结点的数据
    temp->left = NULL;     // 初始化左子结点为NULL
    temp->right = NULL;    // 初始化右子结点为NULL
    return temp;           // 返回新创建的结点
}

// 中序遍历函数
void printInorder(struct Node* node){
    if(node == NULL) return;  // 如果结点为空，返回
    printInorder(node->left); // 首先遍历左子树
    cout << node->data << " "; // 访问根结点
    printInorder(node->right); // 然后遍历右子树
}

// 前序遍历函数
void printPreorder(struct Node* node){
    if(node == NULL) return;   // 如果结点为空，返回
    cout << node->data << " "; // 访问根结点
    printPreorder(node->left); // 遍历左子树
    printPreorder(node->right); // 遍历右子树
}

// 后序遍历函数
void printPostorder(struct Node* node){
    if(node == NULL) return;    // 如果结点为空，返回
    printPostorder(node->left); // 首先遍历左子树
    printPostorder(node->right); // 然后遍历右子树
    cout << node->data << " ";  // 访问根结点
}

int main(){
    
    int n, b, c;
    
    cin >> n; // 读入结点数
    
    // 循环读入每个结点的左右子结点编号
    for (int i = 1; i <= n; i++){
        if(a[i] == NULL) a[i] = newNode(i); // 如果该结点尚未创建，创建它
        cin >> b >> c; // 读入左右子结点的编号
        // 根据读入的编号建立左右子结点
        if(b != 0){
            if(a[b] == NULL) a[b] = newNode(b); // 如果左子结点尚未创建，创建它
            a[i]->left = a[b]; // 设置当前结点的左子结点
        }
        if(c != 0){
            if(a[c] == NULL) a[c] = newNode(c); // 如果右子结点尚未创建，创建它
            a[i]->right = a[c]; // 设置当前结点的右子结点
        }       
    }
    
    // 执行遍历操作
    printPreorder(a[1]);  // 打印前序遍历结果
    cout << endl;
    printInorder(a[1]);   // 打印中序遍历结果
    cout << endl;
    printPostorder(a[1]); // 打印后序遍历结果
   
    return 0;
}
